/**
 * Created by Audy on 21-Mar-16.
 */
app.controller("ContactFormCtrl", function ($scope, $http, httpService, $stateParams, $ionicPlatform, $ionicPopup, $ionicLoading) {

    $scope.input = {
        content: '',
        meta: {
            email: email,
            name: username_login
        }
    };

    $scope.isLoading = true;
        
    var loadCustomText = function() {        
        $scope.input_text_email = "Email";
        $scope.input_placeholder_email = "Email";
        $scope.input_required_error_email = "Email must be filled";
        $scope.input_format_error_email = "Wrong format for email field";        
        $scope.input_text_name = "Name";
        $scope.input_placeholder_name = "Name";
        $scope.input_required_error_name = "Name must be filled";
        $scope.input_format_error_name = "Wrong format for name field";        
        $scope.input_text_content = "Content";
        $scope.input_placeholder_content = "Content";
        
        input_text_email = ui_texts_contact_forms.input_text_email !== undefined && ui_texts_contact_forms.input_text_email[language]!==undefined ? ui_texts_contact_forms.input_text_email[language] : "Email";
        $scope.input_text_email = input_text_email;
        
        input_placeholder_email = ui_texts_contact_forms.input_placeholder_email !== undefined && ui_texts_contact_forms.input_placeholder_email[language]!==undefined ? ui_texts_contact_forms.input_placeholder_email[language] : "Email";
        $scope.input_placeholder_email = input_placeholder_email;
        
        input_required_error_email = ui_texts_contact_forms.input_required_error_email !== undefined && ui_texts_contact_forms.input_required_error_email[language]!==undefined ? ui_texts_contact_forms.input_required_error_email[language] : "Email must be filled";
        $scope.input_required_error_email = input_required_error_email;
        
        input_format_error_email = ui_texts_contact_forms.input_format_error_email !== undefined && ui_texts_contact_forms.input_format_error_email[language]!==undefined ? ui_texts_contact_forms.input_format_error_email[language] : "Wrong format for email field";
        $scope.input_format_error_email = input_format_error_email;
        
        input_text_name = ui_texts_contact_forms.input_text_name !== undefined && ui_texts_contact_forms.input_text_name[language]!==undefined ? ui_texts_contact_forms.input_text_name[language] : "Name";
        $scope.input_text_name = input_text_name;
        
        input_placeholder_name = ui_texts_contact_forms.input_placeholder_name !== undefined && ui_texts_contact_forms.input_placeholder_name[language]!==undefined ? ui_texts_contact_forms.input_placeholder_name[language] : "Name";
        $scope.input_placeholder_name = input_placeholder_name;
        
        input_required_error_name = ui_texts_contact_forms.input_required_error_name !== undefined && ui_texts_contact_forms.input_required_error_name[language]!==undefined ? ui_texts_contact_forms.input_required_error_name[language] : "Name must be filled";
        $scope.input_required_error_name = input_required_error_name;
        
        input_format_error_name = ui_texts_contact_forms.input_format_error_name !== undefined && ui_texts_contact_forms.input_format_error_name[language]!==undefined ? ui_texts_contact_forms.input_format_error_name[language] : "Wrong format for name field";
        $scope.input_format_error_name = input_format_error_name;
        
        input_text_content = ui_texts_contact_forms.input_text_content !== undefined && ui_texts_contact_forms.input_text_content[language]!==undefined ? ui_texts_contact_forms.input_text_content[language] : "Content";
        $scope.input_text_content = input_text_content;
        
        input_placeholder_content = ui_texts_contact_forms.input_placeholder_content !== undefined && ui_texts_contact_forms.input_placeholder_content[language]!==undefined ? ui_texts_contact_forms.input_placeholder_content[language] : "Content";
        $scope.input_placeholder_content = input_placeholder_content;

    }
    
    loadCustomText();

    var url = token_url;
    var obj = serializeData({email: username, password: password, company_id: company_id});
    // call angular http service
    httpService.post_token($scope, $http, url, obj);

    
    $scope.$on('httpService:postTokenSuccess', function () {
        token = $scope.data.token;
        //console.log(token);
        var url = post_content_url + $stateParams.id;

        // get data
        httpService.get($scope, $http, url, 'content', token);
        console.log('UserFormCtrl');

    });
    
    $scope.$on('httpService:getRequestSuccess', function () {
        //console.log($scope.data);

        $scope.content_data = {
            id: $stateParams.id,
            title: $scope.data.post.title
        };
        $scope.isLoading = false;
        
        if(isPhoneGap())
        {
            //console.log($stateParams.id + " " + $scope.data.post.term_id + " " + 'ArticleDetailCtrl' + " " + $scope.data);
            savePostJSONToDB($stateParams.id, $scope.data.post.term_id, 'ArticleDetailCtrl', $scope.data);
            //console.log('saved');
        }

    });

    $scope.submitForm = function () {
        //console.log($scope.input.meta);
        $scope.show();
        var url = token_url;
        var obj = serializeData({email: username, password: password, company_id: company_id});
        httpService.post_token($scope, $http, url, obj, 'user-form');

        //console.log($scope.input);
    };

    // if get token success, request profile data
    $scope.$on('httpService:postTokenUserFormSuccess', function () {
        //console.log($scope.data);
        token = $scope.data.token;
        var tempString = JSON.stringify($scope.input.meta);

        var obj = serializeData({_method: 'POST', content: $scope.input.content, post_id: $stateParams.id, user_id: user_id, company_id: company_id, meta: tempString});

        // post comment
        //console.log(obj);
        httpService.post($scope, $http, user_form_url + '?token=' + token, obj, 'user-form');
    });


    $scope.$on('httpService:postUserFormSuccess', function () {
        $scope.hide();
        if($scope.data.success === true)
        {
            $scope.showSubmitFormSuccessAlert();
        }
        else
        {
            $scope.showSubmitFormFailedAlert();
        }
    });

    $scope.$on('httpService:postTokenUserFormFailed', function () {
        $scope.hide();
        $scope.showFailedAlert();
    });

    $scope.$on('httpService:postUserFormError', function () {
        $scope.hide();
        $scope.showFailedAlert();
    });



    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };

    $scope.hide = function () {
        $ionicLoading.hide();
    };

    $scope.showSubmitFormSuccessAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Form',
            template: '<div style="width:100%;text-align:center">Submit Form Success</div>'
        });
    };

    $scope.showSubmitFormFailedAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Form',
            template: '<div style="width:100%;text-align:center">Submit Form Failed. Please Check Your Internet Connection and Try Again</div>'
        });
    };

    $scope.showFailedAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Login',
            template: '<div style="width:100%;text-align:center">Submit Form Failed. Please Check Your Internet Connection and Try Again</div>'
        });
    };




});