var app = angular.module('starter.controllers', ['ionic-audio','ngCordova', 'ngRoute', 'ngSanitize']);

// URLs
var app_type = 'app'; // app, studio
var token = '';
var api_url = app_environment=='local'?'http://api.compro.dev':app_environment=='staging'?'http://dev-api.compro.co.id':'https://api.compro.id';
var base_url = api_url + '/v1/';
var token_url = base_url + 'generate-token';

var post_content_url = base_url + 'posts/';
var post_compressed_content_url = base_url + 'posts-compressed/';
var term_content_url = base_url + 'terms/';
var term_compressed_content_url = base_url + 'terms-compressed/';

var post_content_url_no_token = base_url + 'posts-no-token/';
var post_compressed_content_url_no_token = base_url + 'posts-compressed-no-token/';
var term_content_url_no_token = base_url + 'terms-no-token/';
var term_compressed_content_url_no_token = base_url + 'terms-compressed-no-token/';

var notification_list_content_url = base_url + 'notification/';

var term_resources_base_url = api_url + '/59a03112791d907c6cda46740ae62d04/terms/';
var post_resources_base_url = api_url + '/59a03112791d907c6cda46740ae62d04/posts/';
var post_files_base_url = api_url + '/59a03112791d907c6cda46740ae62d04/posts/';

var menu_url = base_url + 'company/' + company_id;
var options_url = base_url+ 'company/'+company_id+'/options';
var login_url = base_url + 'company-user-login';
var logout_url = base_url + 'company-user-logout';
var register_url = base_url + 'company-user-register';
var change_password_url = base_url + 'company-user-change-password';
var reset_password_url = base_url + 'company-user-forgot-password';
var user_form_url = base_url + 'user-post';
var top_up_purchase_url = base_url + 'company-user-top-up-purchase';
var save_transaction_receipt_url = base_url + 'company-user-save-transaction-receipt';
    
var search_url = base_url + 'companies/search';
var comments_url = base_url + 'comments';
var comment_list_url = base_url + 'get-post-comments/';
var likes_url = base_url + 'likes';
var send_email_url = base_url + 'companies/' + company_id + '/send-email';
var register_push_notif_url = 'register-device';   // return {success:'true/false', device:{registration_id:'<registration_id>',company_id:'<company_id>',device_id:'<device_id>'}}
var profile_url = base_url + 'company-user-profile';
var company_options_url = base_url + "companies/" + company_id + "/options";
var company_user_device_url = base_url + "get-company-user-device-id";
var company_user_expiration_url = base_url + "get-company-user-expiration";
var user_transaction_list = base_url + "transaction-list/";
var user_transaction_detail = base_url + "transaction-detail/";
var user_booking_history = base_url + "booking-history/";
var update_transfer_receipt = base_url + "update-transaction/" ;
var user_cancel_booking = base_url + "cancel-booking/";

var raja_ongkir_province = base_url + 'raja-ongkir-province/';
var raja_ongkir_city = base_url + 'raja-ongkir-city/';
var raja_ongkir_cost = base_url + 'raja-ongkir-cost/';

var sicepat_province = base_url + 'get-sicepat-provinces';
var sicepat_data_by_province = base_url + 'get-sicepat-data-by-province/';
var sicepat_tariff = base_url + 'get-sicepat-tariff';
var sicepat_track_waybill = base_url + 'track-sicepat-waybill/';
var sicepat_waybillNumber = base_url + 'get-sicepat-waybillNumber/';

var event_calendar_url = base_url + 'get-calendar/';

// Studio API url
var studio_login_url = base_url + 'studio-login';
var studio_app_list_url = base_url + 'studio-app-list';
var studio_app_url = base_url + 'studio-app';
var studio_app_published_url = base_url + 'studio-app-published';

// User Variables
var user_table = 'users_001';
var username_login = '';
var user_id = '';
var is_expired = true;
var address = '';
var phone = '';
var email = '';

// Studio User Variables
var st_user_table = 'st_users_001';
var st_username_login = '';
var st_user_id = '';
var st_email = '';
var st_app_id = '';
var st_is_expired = true;
var st_login_menu = 'Member';
var st_sqlitedb = 'compro.comprostudio.db';
var st_menu_template = 'studio/studio-menu.html';
var st_app_package = 'id.compro.comprostudio';
var st_db = '';
var st_preview_app = true;

// VARIABLES
var language = 'english';
var default_menu_titles = false;
var custom_feedback_message = false;
var manual_payment_method_list = false;
var manual_payment_instruction = "";
var custom_tax_fields  = false;
var shopping_tnc = "";
var main_menu = '';
var db = '';
var map = null;
var currency = 'Rp ';
var shoppingCharts = new Array();
var stock_status_visible = false;
var login_menu = 'Login';
var updated_time = '';
var canAttendEvent = true;
var isLoginEnabled = false;
var isDeviceLogin = false;
var shopping_enabled = false;
var tax_enabled = false;
var booking_enabled = false;
var curr_device_id = '';
var home_share_apps = false;
var showNotificationListMenu = true;
var loadCompressedImages = true;
var game001Enabled = false;
var doregisterHardBack = null;
var rajaongkir_enabled = 'NO';
var sicepat_enabled = 'NO';
var rajaongkir_sender_city_id = '152';
var sicepat_origin = 'CGK';
var rajaongkir_selected_services = '';

//ui_texts
var ui_texts_products = false;
var ui_texts_events = false;
var ui_texts_bookings = false;
var ui_texts_careers = false;
var ui_texts_audios = false;
var ui_texts_custom_forms = false;
var ui_texts_files = false;
var ui_texts_webviews = false;
var ui_texts_contacts = false;
var ui_texts_contact_forms = false;
var ui_texts_transactions = false;
var ui_texts_manual_payments = false;
var ui_texts_shopping_cart = false;
var ui_texts_register = false;
var ui_texts_login = false;
var ui_texts_general = false;

// Audio Variables
var audioTrackData = '';
var audioDetailData = '';
var audioListTemplateName = '';
var audioListTermId = '';
var audioFileLocation = '';
var audioDownloadEnabled = false;

// Push Notification Variables
var sender_id = "731865515138";
var registration_id = '';// di-generate setelah request OK dari GCM
var device_id = '';      // di-generate sesuai device (automatic)
var flagPushLocalNotif = false;

// Publish Links
var playstore_link = 'https://play.google.com/store/apps/details?id=id.compro.' + package_name;
var appstore_link = 'https://itunes.apple.com';

var ionicLoadingTemplate = '<div style="display:flex;justify-content:center;align-items:center;">Loading.. <ion-spinner></ion-spinner></div>';
//var timeout_value = 500;

// Register Variables
var user_meta = {}; //buat nampung user_meta setelah login
var register_phone_required = 'YES';
var register_address_required = 'NO';
var register_message_required = 'NO';
var field_title_register_additional_message = "";
var custom_register_fields  = false;
var default_register_fields  = false;
var custom_transaction_fields = false;
var default_transaction_fields = false;
var sku_enabled = 'NO';

var inAppPurchaseEnabled = false;

var is_membership_enabled = 'NO';

var membership_product_data_android = [];
var vt_payment_service = 'NO';

var maintenance_enabled = 'NO';
//var productIds = [
//    'id.compro.po1toolbox.product1',
//    'id.compro.po1toolbox.product2',
//    'id.compro.po1toolbox.product3']; 
