app.controller('AppCtrl', function ($scope,
                                    $ionicModal,
                                    $timeout,
                                    $http,
                                    httpService,
                                    $ionicHistory,
                                    $ionicPlatform,
                                    $ionicPopup,
                                    $state,
                                    $cordovaDevice,
                                    $rootScope,
                                    $cordovaLocalNotification,
                                    notifService,
                                    $cordovaVibration,
                                    $cordovaClipboard,
                                    //adMobService,
                                    $cordovaToast) {

    $scope.isloading = true;
    $scope.isLogin = false;
    $scope.login_enabled = 'NO';
    $scope.selected_menu = 0;
    $rootScope.totalQty = 0;
    $rootScope.manual_payment = false;
    $rootScope.isLoggedIn = false;
    $rootScope.jne_service = 'NO';
    
    $rootScope.transaction_count = 0;
    
    menu_text_login = "Login";
    menu_text_user = "User";
    menu_text_notif = "Notification List";
    menu_text_cart = "Shopping Cart";
    menu_text_search = "Search";
    menu_text_share = "Share Apps";
    
    $scope.menu_text_share = "Share Apps";
    is_expired = false;

    $ionicPlatform.ready(function () {
        console.log('App Controller');
        console.log(navigator.userAgent);
        console.log('Android: ' + isAndroid());
        console.log('iOS: ' + isIOS());

        $scope.app_type = app_type;

        if (isPhoneGap()) {
            // adMobService.initBannerAd();
            // check if any user login data stored in database
            if (db === '') {
                db = window.sqlitePlugin.openDatabase({name: sqlitedb, location: 'default'});
                console.log("HOME db sqlite");
            }

            if (user_id == '') {
                db.transaction(function (tx) {
                    //tx.executeSql('DROP TABLE IF EXISTS contents'); // for DEBUG purposes only
                    //tx.executeSql('DROP TABLE IF EXISTS ' + user_table); // remove old users table
                    tx.executeSql('CREATE TABLE IF NOT EXISTS ' + user_table + ' (id INTEGER PRIMARY KEY, user TEXT)');
                    tx.executeSql("SELECT id, user FROM " + user_table, [],
                        function (tx, res) {
                            if (res.rows.length >= 1) {
                                var data = JSON.parse(res.rows.item(0).user);

                                user_id = res.rows.item(0).id;
                                username_login = data.username;
                                email = data.email;
                                login_menu = menu_text_user;

                                // if (getPostMetaValueById(data.company_user_meta, 'address') != null && getPostMetaValueById(data.company_user_meta, 'address') != undefined) {
                                //     address = getPostMetaValueById(data.company_user_meta, 'address').value;
                                // }
                                //
                                // if (getPostMetaValueById(data.company_user_meta, 'phone') != null && getPostMetaValueById(data.company_user_meta, 'phone') != undefined) {
                                //     phone = getPostMetaValueById(data.company_user_meta, 'phone').value;
                                // }

                                var temp_user_meta = data.company_user_meta;
                                for(var i=0; i<temp_user_meta.length; i++)
                                {
                                    var key = temp_user_meta[i]['key'];
                                    var value = temp_user_meta[i]['value'];
                                    if (key.indexOf('_date') !== -1) {
                                        value = new Date(value);
                                    }
                                    user_meta[key] = value;
                                }
                                
                                console.log('USER LOGGED IN');
                                //console.log(user_id + ' ' + username_login);
                                $scope.isLogin = true;
                                $rootScope.isLoggedIn = true;
                                main_menu['transaction_list'] = $scope.isLogin;
                                
                                if (getPostMetaValueById(data.company_user_meta, 'expired_date') != null && getPostMetaValueById(data.company_user_meta, 'expired_date') != undefined) {
                                    var d1 = new Date();
                                    var d2 = new Date(value);
                                    console.log(d1);
                                    console.log(d2);
                                    var oneDay = 24*60*60*1000; // hours*minutes*seconds*milliseconds

                                    var diffDays = Math.round(Math.abs((d2.getTime() - d1.getTime())/(oneDay)));
                                    if(d1<=d2)
                                    {
                                        console.log("active");
                                        is_expired = false;
                                    }
                                    else
                                    {
                                        console.log("expired");
                                        $scope.isLogin = false;
                                        main_menu['transaction_list'] = $scope.isLogin;
                                        is_expired = true;
                                    }
                                }
                                else
                                {
                                    
                                }
                                
                                console.log("*** User ID: " + user_id + " ***");
                                var url = menu_url + "/" + user_id;
                                httpService.get($scope, $http, url, 'menu');
                            }
                            else {
                                console.log('USER LOGGED OUT');
                                $scope.isLogin = false;
                                main_menu['transaction_list'] = $scope.isLogin;
                                is_expired = true;
                                
                                console.log("*** User ID: " + user_id + " ***");
                                var url = menu_url;// + "/" + user_id;
                                if (app_type != 'studio')
                                    httpService.get($scope, $http, url, 'menu');
                            }
                        },
                        function (e) {
                            console.log('USER LOGGED OUT');
                            $scope.isLogin = false;
                            main_menu['transaction_list'] = $scope.isLogin;
            
                            console.log("*** User ID: " + user_id + " ***");
                            var url = menu_url;// + "/" + user_id;
                            if (app_type != 'studio')
                                httpService.get($scope, $http, url, 'menu');
                        }
                    );
                });

                loadCartFromDB($scope, $rootScope);
            }

            // Push Notification
            // when device is ready, register the device to the server.
            console.log("PushNotif: Init");
            if (app_type != 'studio'){
                var push = PushNotification.init({
                    android: {
                        senderID: sender_id    // Google Dev Console Project Number
                    },
                    ios: {
                        alert: "true",
                        badge: "true",
                        sound: "true"
                    },
                    windows: {}
                });

                //  console.log("PushNotif: ");
                //  console.log(push);

                push.on('registration', function (data) {
                    registration_id = data.registrationId;
                    device_id = $cordovaDevice.getDevice().uuid;
                    //  console.log("PushNotif: RegistrationID: " + registration_id);
                    //  console.log("PushNotif: DeviceID: " + device_id);
                    //  console.log("PushNotif: CompanyID: " + company_id);

                    var url = token_url;
                    var obj = serializeData({email: username, password: password, company_id: company_id});
                    httpService.post_token($scope, $http, url, obj, 'push_notif');
                });

                push.on('notification', function (data) {
                    // what do you want to do on notification?
                    // data.message,
                    // data.title,
                    // 
                    // data.count,
                    // data.sound,
                    // data.image,
                    // data.additionalData
                    // console.log("Push Notif When Opened: ");
                    // console.log(data);

                    if (!flagPushLocalNotif) {
                        if(!is_expired)
                        {
                            window.location.href = "#/app/" + data.additionalData.target;
                        }
                        flagPushLocalNotif = true;
                    }
                    else {
                        notifService.showNotification($scope,
                            $rootScope,
                            $ionicPlatform,
                            $cordovaLocalNotification,
                            $cordovaVibration,
                            $ionicPopup,
                            data);
                    }

                    //  $scope.data = {
                    //      registerID: JSON.stringify(data)
                    //  };
                });

                push.on('error', function (e) {
                    // e.message
                    console.log(e);
                    //  $scope.data = {
                    //      registerID: JSON.stringify(e)
                    //  };
                });
            }
            // loadJSONFromDB(-1, $scope);
        }
        else {
            // var url = token_url;
            // var obj = serializeData({email: username, password: password, company_id: company_id});
            // httpService.post_token($scope, $http, url, obj, 'menu');
            console.log("*** User ID: " + user_id + " ***");
            
            var url = menu_url + (user_id == '' || user_id == undefined || user_id == false ? '' : '/' + user_id);//+ "/" + user_id;
            if (app_type != 'studio')
                httpService.get($scope, $http, url, 'menu');
        }
    });

    // if get token for menu success, get data menu
    $scope.$on('httpService:postTokenMenuSuccess', function () {
        token = $scope.data.token;
        console.log("APP: TOKEN SUCCESS" + token);
        //console.log(token);

        var url = menu_url + "/" + user_id;
        httpService.get($scope, $http, url, 'menu');

    });

    // if get token for menu failed, request token again
    $scope.$on('httpService:postTokenMenuError', function () {
        if ($scope.status === 0) {
            console.log('NO INTERNET CONNECTION');
            if (isPhoneGap()) {
                loadTermJSONFromDB(-1, $scope);
            }
        }
        else {
            var url = token_url;
            var obj = serializeData({email: username, password: password, company_id: company_id});
            httpService.post_token($scope, $http, url, obj, 'menu');

        }
    });

    $scope.$on('httpService:getDeviceIdSuccess', function() {
        curr_device_id = $scope.data.device_id;
        console.log('Device ID: ' + curr_device_id);
        var user_device_id = '';
        if (isPhoneGap()) {
            user_device_id = $cordovaDevice.getDevice().uuid;
        }
        if (curr_device_id != user_device_id && user_id != '' && isPhoneGap()) {
            // Logged in to other device, logging out...
            var alertPopup = $ionicPopup.alert({
                title: 'Logged In',
                css: 'cp-button',
                template: "<div style='display:flex;justify-content:center;align-items:center;'>You are logged in to other device. Please relogin to this device.</div>",
                okType:'cp-button'
            });

            //confirmation dialog
            alertPopup.then(function (res) {
                if (res) {
                    console.log('USER LOGGED OUT');
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $ionicHistory.clearHistory();
                    $scope.do_logout();
                    $ionicHistory.clearHistory();
                }
            });
        }
    });

    $scope.$on('httpService:getUserExpirationSuccess', function() {
        is_expired = $scope.data.is_expired;
        console.log('is_expired: ' + is_expired);
        if (is_expired) {
            var alertPopup = $ionicPopup.alert({
                title: 'Logged In',
                css: 'cp-button',
                template: "<div style='display:flex;justify-content:center;align-items:center;'>Your Account Has Expired</div>",
                okType:'cp-button'
            });
            alertPopup.then(function (res) {
                if (res) {

                    console.log('USER LOGGED OUT');
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $ionicHistory.clearHistory();
                    $scope.do_logout();
                    $ionicHistory.clearHistory();
                }
            });
        }
    });
    
    $scope.do_logout = function () {
        //confirmation dialog
        var device_id = '';
        if (isPhoneGap()) {
            device_id = $cordovaDevice.getDevice().uuid;
        }
        //device_id = '2c5652e569bba77f'; // Testing Purposes Only
        var url = logout_url + '?user_id=' + user_id + '&company_id=' + company_id + '&device_id=' + device_id ;
        httpService.get($scope, $http, url, 'logout');

        if (isPhoneGap()) {
            //console.log(db);
            if (db === '') {
                db = window.sqlitePlugin.openDatabase({name: sqlitedb, location: 'default'});
            }
            db.transaction(function (tx) {
                //tx.executeSql('DROP TABLE IF EXISTS ' + user_table);
                //console.log(user_id + " " + username_login);
                tx.executeSql("DELETE FROM " + user_table, [], function (tx, res) {
                    //apus dari db
                    user_id = '';
                    username_login = '';
                    email = '';
                    phone = '';
                    address = '';

                    $scope.isLogin = false;
                    login_menu = menu_text_login;
                    $scope.title = login_menu;

                    var idx = main_menu.findIndex(checkTemplate);
                    main_menu[idx].title = login_menu;
                    // main_menu[main_menu.length - 4].title = login_menu;

                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $ionicHistory.clearHistory();

                    if (login_required == true) {
                        login_menu = menu_text_user;
                        var idx = main_menu.findIndex(checkTemplate);
                        main_menu[idx].title = login_menu;
                        // main_menu[main_menu.length - 4].title = login_menu;
                        $state.go("login");
                        $ionicHistory.clearHistory();
                    } else {
                        $state.go('app.' + home_template, {id: home_id});
                        $ionicHistory.clearHistory();
                    }

                }, function (e) {
                    console.log("ERROR: " + e.message);
                    $scope.isLogin = true;
                });
            });
        }
        else {

            user_id = '';
            username_login = '';
            email = '';
            phone = '';
            address = '';

            $scope.isLogin = false;
            login_menu = menu_text_login;
            $scope.title = login_menu;

            // console.log(main_menu[main_menu.length - 3]);
            var idx = main_menu.findIndex(checkTemplate);
            main_menu[idx].title = login_menu;
            // main_menu[main_menu.length - 4].title = login_menu;

            $ionicHistory.nextViewOptions({
                disableBack: true
            });
            $ionicHistory.clearHistory();

            if (login_required == true) {
                login_menu = menu_text_user;
                var idx = main_menu.findIndex(checkTemplate);
                main_menu[idx].title = login_menu;
                // main_menu[main_menu.length - 4].title = login_menu;
                $state.go("login");
                $ionicHistory.clearHistory();
            } else {
                $state.go('app.' + home_template, {id: home_id});
                $ionicHistory.clearHistory();
            }
        }
    };

    $scope.getMenuSuccess = function () {

        console.log('GET MENU SUCCESS');
        if (app_type === 'studio'){
            $scope.data = $rootScope.data;
            // override back button
            doregisterHardBack = $ionicPlatform.registerBackButtonAction(doCustomBack, 101);
        }
//        else if ($rootScope.isLoginRefresh != undefined && $rootScope.isLoginRefresh == true){
//            $scope.data = $rootScope.data;
//            console.log("overriding menu data");
//        }
        
        main_menu = $scope.data.terms;
        console.log(main_menu);
        main_menu['transaction_list'] = $scope.isLogin;

        updated_time = $scope.data.company.updated_at;
        //console.log('Updated At: ' + updated_time);
        var login_enabled = getPostMetaValueById($scope.data.options, "login_enabled");
        isLoginEnabled = login_enabled !== undefined ? (login_enabled.value == 'YES' ? true : false) : false;
        
        register_phone_required = getPostMetaValueById($scope.data.options, "register_phone_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_phone_required").value : 'NO';        
        register_address_required = getPostMetaValueById($scope.data.options, "register_address_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_address_required").value : 'NO';
        register_message_required = getPostMetaValueById($scope.data.options, "register_message_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_message_required").value : 'NO';
        field_title_register_additional_message = getPostMetaValueById($scope.data.options, "field_title_register_additional_message") !== undefined ? getPostMetaValueById($scope.data.options, "field_title_register_additional_message").value : '';

        audioDownloadEnabled = getPostMetaValueById($scope.data.options, "audio_download_enabled")!== undefined ? (getPostMetaValueById($scope.data.options, "audio_download_enabled").value == 'YES' ? true : false) : false;

        canAttendEvent = getPostMetaValueById($scope.data.options, "can_attend_event") !== undefined ? (getPostMetaValueById($scope.data.options, "can_attend_event").value == 'YES' ? true : false):false;

        home_share_apps = getPostMetaValueById($scope.data.options, "home_share_apps") !== undefined ? (getPostMetaValueById($scope.data.options, "home_share_apps").value == 'YES' ? true : false):false;

        isDeviceLogin = getPostMetaValueById($scope.data.options, "is_device_login") !== undefined ? (getPostMetaValueById($scope.data.options, "is_device_login").value == 'YES' ? true : false):false;

        //login_required = getPostMetaValueById($scope.data.options, "login_required");
        shopping_enabled = getPostMetaValueById($scope.data.options, "shopping_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "shopping_enabled").value == 'YES' ? true : false):false;
        
        currency = getPostMetaValueById($scope.data.options, "price_currency") !== undefined ? getPostMetaValueById($scope.data.options, "price_currency").value : 'Rp';
        
        stock_status_visible = getPostMetaValueById($scope.data.options, "stock_status_visible") !== undefined ? getPostMetaValueById($scope.data.options, "stock_status_visible").value : 'NO';
        
        booking_enabled = getPostMetaValueById($scope.data.options, "booking_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "booking_enabled").value == 'YES' ? true : false):false;
        
        playstore_link = getPostMetaValueById($scope.data.options, "link_playstore") !== undefined ? getPostMetaValueById($scope.data.options, "link_playstore").value: '';
        appstore_link = getPostMetaValueById($scope.data.options, "link_appstore") !== undefined ? getPostMetaValueById($scope.data.options, "link_appstore").value: '';
        
        inAppPurchaseEnabled = getPostMetaValueById($scope.data.options, "in_app_purchase_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "in_app_purchase_enabled").value == 'YES' ? true : false):false;
        
        
        is_membership_enabled = getPostMetaValueById($scope.data.options, "is_membership_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "is_membership_enabled").value : 'NO';
        
        membership_product_data_android = getPostMetaValueById($scope.data.options, "membership_product_data_android");
        membership_product_data_android = JSON.parse(membership_product_data_android !== undefined ? membership_product_data_android.value : "[]");
        
        custom_register_fields  = getPostMetaValueById($scope.data.options, "custom_register_fields") !== undefined ? getPostMetaValueById($scope.data.options, "custom_register_fields").value : false;
        default_register_fields  = getPostMetaValueById($scope.data.options, "default_register_fields") !== undefined ? getPostMetaValueById($scope.data.options, "default_register_fields").value : false;

        custom_transaction_fields  = getPostMetaValueById($scope.data.options, "custom_transaction_fields") !== undefined ? getPostMetaValueById($scope.data.options, "custom_transaction_fields").value : false;
        default_transaction_fields  = getPostMetaValueById($scope.data.options, "default_transaction_fields") !== undefined ? getPostMetaValueById($scope.data.options, "default_transaction_fields").value : false;        
        
        vt_payment_service = getPostMetaValueById($scope.data.options, "vt_payment_service") !== undefined ? getPostMetaValueById($scope.data.options, "vt_payment_service").value : 'NO';
        $rootScope.manual_payment = vt_payment_service=='YES' ? false : true;   
        
        rajaongkir_enabled = getPostMetaValueById($scope.data.options, "rajaongkir_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_enabled").value : 'NO';
        sicepat_enabled = getPostMetaValueById($scope.data.options, "sicepat_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "sicepat_enabled").value : 'NO';

        maintenance_enabled = getPostMetaValueById($scope.data.options, "maintenance_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "maintenance_enabled").value : 'NO';
        
        rajaongkir_sender_city_id = getPostMetaValueById($scope.data.options, "rajaongkir_sender_city_id") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_sender_city_id").value : '152';
        sicepat_origin = getPostMetaValueById($scope.data.options, "sicepat_origin") !== undefined ? getPostMetaValueById($scope.data.options, "sicepat_origin").value : 'CGK';

        rajaongkir_selected_services = getPostMetaValueById($scope.data.options, "rajaongkir_selected_services") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_selected_services").value : '';

        $rootScope.jne_service = getPostMetaValueById($scope.data.options, "jne_service") !== undefined ? getPostMetaValueById($scope.data.options, "jne_service").value : 'NO';
        
        sku_enabled = getPostMetaValueById($scope.data.options, "sku_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "sku_enabled").value : 'NO';
        
        default_menu_titles =  getPostMetaValueById($scope.data.options, "default_menu_titles") !== undefined ? getPostMetaValueById($scope.data.options, "default_menu_titles").value : false;
        
        if(default_menu_titles!=false)
        {
            default_menu_titles = JSON.parse(default_menu_titles);
            console.log(default_menu_titles);
            
            menu_text_login = default_menu_titles.login !== undefined && default_menu_titles.login[language]!==undefined ? default_menu_titles.login[language] : "Login";
            
            menu_text_user = default_menu_titles.user !== undefined && default_menu_titles.user[language]!==undefined ? default_menu_titles.user[language] : "User";
            
            menu_text_notif = default_menu_titles.notification !== undefined && default_menu_titles.notification[language]!==undefined ? default_menu_titles.notification[language] : "Notification List";
            
            menu_text_cart = default_menu_titles.cart !== undefined && default_menu_titles.cart[language]!==undefined ? default_menu_titles.cart[language] : "Shopping Cart";
            
            menu_text_search = default_menu_titles.search !== undefined && default_menu_titles.search[language]!==undefined ? default_menu_titles.search[language] : "Search";
            
            menu_text_share = default_menu_titles.share !== undefined && default_menu_titles.share[language]!==undefined ? default_menu_titles.share[language] : "Share Apps";
            $scope.menu_text_share = menu_text_share;
            
            console.log("==========================================================");
            console.log(default_menu_titles.search[language])
            console.log("==========================================================");
            
            if(login_menu=="Login") login_menu = menu_text_login;
            else if(login_menu=="User") login_menu = menu_text_user;
        }
        else
        {
            menu_text_login = "Login";
            menu_text_user = "User";
            menu_text_notif = "Notification List";
            menu_text_cart = "Shopping Cart";
            menu_text_search = "Search";
            menu_text_share = "Share Apps";
        }
        
        ui_texts_products =  getPostMetaValueById($scope.data.options, "ui_texts_products") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_products").value : false;
        
        if(ui_texts_products!=false)
        {
            ui_texts_products = JSON.parse(ui_texts_products);
        }
        
        ui_texts_events =  getPostMetaValueById($scope.data.options, "ui_texts_events") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_events").value : false;
        
        if(ui_texts_events!=false)
        {
            ui_texts_events = JSON.parse(ui_texts_events);
        }
        
        ui_texts_bookings =  getPostMetaValueById($scope.data.options, "ui_texts_bookings") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_bookings").value : false;
        
        if(ui_texts_bookings!=false)
        {
            ui_texts_bookings = JSON.parse(ui_texts_bookings);
        }
        
        ui_texts_careers =  getPostMetaValueById($scope.data.options, "ui_texts_careers") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_careers").value : false;
        
        if(ui_texts_careers!=false)
        {
            ui_texts_careers = JSON.parse(ui_texts_careers);
        }
        
        ui_texts_audios =  getPostMetaValueById($scope.data.options, "ui_texts_audios") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_audios").value : false;
        
        if(ui_texts_audios!=false)
        {
            ui_texts_audios = JSON.parse(ui_texts_audios);
        }
        
        ui_texts_custom_forms =  getPostMetaValueById($scope.data.options, "ui_texts_custom_forms") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_custom_forms").value : false;
        
        if(ui_texts_custom_forms!=false)
        {
            ui_texts_custom_forms = JSON.parse(ui_texts_custom_forms);
        }
        
        ui_texts_files =  getPostMetaValueById($scope.data.options, "ui_texts_files") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_files").value : false;
        
        if(ui_texts_files!=false)
        {
            ui_texts_files = JSON.parse(ui_texts_files);
        }
        
        ui_texts_webviews =  getPostMetaValueById($scope.data.options, "ui_texts_webviews") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_webviews").value : false;
        
        if(ui_texts_webviews!=false)
        {
            ui_texts_webviews = JSON.parse(ui_texts_webviews);
        }
        
        ui_texts_contacts =  getPostMetaValueById($scope.data.options, "ui_texts_contacts") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_contacts").value : false;
        
        if(ui_texts_contacts!=false)
        {
            ui_texts_contacts = JSON.parse(ui_texts_contacts);
        }
        
        ui_texts_contact_forms =  getPostMetaValueById($scope.data.options, "ui_texts_contact_forms") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_contact_forms").value : false;
        
        if(ui_texts_contact_forms!=false)
        {
            ui_texts_contact_forms = JSON.parse(ui_texts_contact_forms);
        }
        
        ui_texts_transactions =  getPostMetaValueById($scope.data.options, "ui_texts_transactions") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_transactions").value : false;
        
        if(ui_texts_transactions!=false)
        {
            ui_texts_transactions = JSON.parse(ui_texts_transactions);
        }
        
        ui_texts_manual_payments =  getPostMetaValueById($scope.data.options, "ui_texts_manual_payments") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_manual_payments").value : false;
        
        if(ui_texts_manual_payments!=false)
        {
            ui_texts_manual_payments = JSON.parse(ui_texts_manual_payments);
        }
        
        ui_texts_shopping_cart =  getPostMetaValueById($scope.data.options, "ui_texts_shopping_cart") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_shopping_cart").value : false;
        
        if(ui_texts_shopping_cart!=false)
        {
            ui_texts_shopping_cart = JSON.parse(ui_texts_shopping_cart);
        }
        
        ui_texts_register =  getPostMetaValueById($scope.data.options, "ui_texts_register") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_register").value : false;
        
        if(ui_texts_register!=false)
        {
            ui_texts_register = JSON.parse(ui_texts_register);
        }
        
        ui_texts_login =  getPostMetaValueById($scope.data.options, "ui_texts_login") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_login").value : false;
        
        if(ui_texts_login!=false)
        {
            ui_texts_login = JSON.parse(ui_texts_login);
        }
        
        ui_texts_general =  getPostMetaValueById($scope.data.options, "ui_texts_general") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_general").value : false;
        
        if(ui_texts_general!=false)
        {
            ui_texts_general = JSON.parse(ui_texts_general);
        }
        
        custom_feedback_message =  getPostMetaValueById($scope.data.options, "custom_feedback_message") !== undefined ? getPostMetaValueById($scope.data.options, "custom_feedback_message").value : false;
        
        manual_payment_method_list =  getPostMetaValueById($scope.data.options, "manual_payment_method_list") !== undefined ? getPostMetaValueById($scope.data.options, "manual_payment_method_list").value : false;
        
        manual_payment_instruction =  getPostMetaValueById($scope.data.options, "manual_payment_instruction") !== undefined ? getPostMetaValueById($scope.data.options, "manual_payment_instruction").value : '1. Please transfer the required amount from an ATM or mobile banking to one of the accounts below.  <br/><br/>2. Tap "Take Photo" to take the picture of receipt with your phone camera, or "Choose Photo" to take the picture from gallery.<br/><br/>  3. The picture will be uploaded, the our admin will process your transaction*.<br/><br/><br/>    * Please note that invalid transaction receipt will be ignored.';
        
        shopping_tnc =  getPostMetaValueById($scope.data.options, "shopping_tnc") !== undefined ? getPostMetaValueById($scope.data.options, "shopping_tnc").value : 'Terms and condition dalam transaksi penjualan utk Compro<br/><br/>1. Kebijakan utk customer jika barang yang diterima tidak sesuai dg permintaan yg telah disepakati antara pihak penjual (Compro) dan customer. Kami selaku pihak penjual akan menjamin jika barang yg diterima oleh customer tidak sesuai dengan kriteria dan ksepakatan maka kami siap untuk mengganti barang tersebut 100% sesuai dg kriteria yg disepakati dalam proses jual beli barang dg syarat Batas waktu utk complain barang adalah maks 7 hari setelah barang diterima oleh customer. <br/><br/>2. Kebijakan utk customer jika barang tidak terkirim atau customer tidak menerima barang yang dipesan maka Kami selaku pihak penjual akan mengirim ulang kembali barang tsb dan menjamin 100%  barang dapat diterima oleh customer. Pihak customer diwajibkan utk mengisi alamat pengiriman dengan lengkap dan jelas. Batas waktu utk complain barang tdk sampai adalah maks 12 hari setelah customer melakukan pembayaran';
        
        tax_enabled = getPostMetaValueById($scope.data.options, "tax_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "tax_enabled").value :"NO";
        
        custom_tax_fields  = getPostMetaValueById($scope.data.options, "custom_tax_fields") !== undefined ? getPostMetaValueById($scope.data.options, "custom_tax_fields").value : false;
        
//        var my_data = [
//    {"productId":"id.compro.po1toolbox.product1", "duration":365},
//    {"productId":"id.compro.po1toolbox.product2", "duration":730},
//    {"productId":"id.compro.po1toolbox.product3", "duration":1095}]; 
//        console.log("data");
//        console.log(JSON.stringify(my_data));
//        
//        var new_data = JSON.stringify(my_data);
        
        
        //check if maintenance
        if (maintenance_enabled == 'YES')
        {
            $state.go('maintenance');
        }

        if (shopping_enabled == true) {
            var Object1 = {
                id: -3, //'shopping_cart',
                content_type_id: '1',
                icon_code: 'icon ion-ios-cart',
                term_template: {name: 'shopping-cart-1'},
                title: menu_text_cart,
                no: 1000
            };

//            var Object2 = {
//                id: -2, //'shopping_cart',
//                content_type_id: '1',
//                icon_code: 'icon ion-ios-cart',
//                term_template: {name: 'shopping-cart-2'},
//                title: 'Shopping Cart 2',
//                no: 1001
//            };

            main_menu.push(Object1);
//            main_menu.push(Object2);

        }

        if (login_enabled.value === 'YES') {
            if (login_required) {
                login_menu = menu_text_user;
            }
            var Object = {
                id: -1, //'login',
                content_type_id: '1',
                icon_code: 'icon ion-log-in',
                term_template: {name: 'login'},
                title: login_menu,
                no: 1003
            };

            main_menu.push(Object);

            //$scope.main_menu_post.push(Object);
        }
        
        if (showNotificationListMenu == true) {
            var Object1 = {
                id: company_id, //'shopping_cart',
                content_type_id: '1',
                icon_code: 'icon ion-android-notifications',
                term_template: {name: 'notif-list'},
                title: menu_text_notif,
                no: 1000
            };


            main_menu.push(Object1);
//            main_menu.push(Object2);

        }
        var ObjectSearch = {
            id: -4, //'search',
            content_type_id: '1',
            icon_code: 'icon ion-search',
            term_template: {name: 'search'},
            title: menu_text_search,
            no: 1004
        };

        main_menu.push(ObjectSearch);

        var ShareApps = {
            id: -5,
            icon_code: 'icon ion-android-share-alt',
            title: menu_text_share,
            no: 1005
        };

        main_menu.push(ShareApps);
        //console.log(main_menu);
        
//        var InAppPurchase = {
//            id: -6,
//            content_type_id: '1',
//            icon_code: 'icon ion-social-android',
//            term_template: {name: 'purchase'},
//            title: 'In App Purchase',
//            no: 1006
//        };
//
//        if (inAppPurchaseEnabled) {
//            main_menu.push(InAppPurchase);
//        }
        
        var Game001Settings = {
            id: -7,
            content_type_id: '1',
            icon_code: 'icon ion-ios-game-controller-b',
            term_template: {name: 'games-001-setting'},
            title: 'Game 1 Settings',
            no: 1006
        };
        if (game001Enabled) {
            main_menu.push(Game001Settings);
        }
        
        $scope.main_menu = null;
        $scope.main_menu_post = $scope.data;
        $scope.main_menu = main_menu;
        $scope.login_enabled = login_enabled.value;
        $scope.login_required = login_required.value;
        $scope.shopping_enabled = shopping_enabled;
        $scope.booking_enabled = booking_enabled;
        $scope.menu_type = menu_type;
        $scope.menu_template = menu_template;
        $scope.tab_type = tab_type;
        $scope.rajaongkir_enabled = rajaongkir_enabled;
        $scope.sicepat_enabled = sicepat_enabled;

        // $scope.$apply();

        // SAVE menu data to SQLite
        if (isPhoneGap()) {
            saveTermJSONToDB(-1, 'AppCtrl', $scope.data);
        }
        $scope.isloading = false;


        if (isDeviceLogin == true) {

            var url = company_user_device_url + '?user_id=' + encodeURIComponent(user_id) + '&company_id=' + encodeURIComponent(company_id);
            httpService.get($scope, $http, url, 'device_id', '');

        }
        
        
        if (is_membership_enabled == 'YES') {

            var url = company_user_expiration_url + '?user_id=' + encodeURIComponent(user_id) + '&company_id=' + encodeURIComponent(company_id);
            httpService.get($scope, $http, url, 'user_expiration', '');

        }
    };

    // refresh menu on login & logout (user group)
    $rootScope.$on('httpService:refreshMenu',function(){
        var url = '';
        console.log("rootScope.user_id: " + $rootScope.user_id);
        if ($rootScope.user_id != undefined && $rootScope.user_id != '')
            url = menu_url + '/' + user_id;
        else 
            url = menu_url;
        
        httpService.get($scope, $http, url, 'menu');
    }); 
       
    // refresh menu on studio.
    $rootScope.$on('httpService:refreshMenuSuccess',function(){
        console.log("Refresh Menu Success!!");
        $scope.getMenuSuccess();
    });
    
    $scope.$on('httpService:getMenuSuccess',$scope.getMenuSuccess);

    // if get menu data error, request token again
    $scope.$on('httpService:getMenuError', function () {
        if ($scope.status === 0 || $scope.status == '' || $scope.status == '-1') {
            console.log('NO INTERNET CONNECTION');
            if (isPhoneGap()) {
                loadTermJSONFromDB(-1, $scope);
            }
        }
        else {
            var url = menu_url + "/" + user_id;
            var obj = serializeData({email: username, password: password, company_id: company_id});
            httpService.get($scope, $http, url, 'menu');
        }
        // httpService.post_token($scope, $http, url, obj, 'menu');


    });

    var doCustomBack = function () {
        console.log("*** Back App Controller ***");
        switch(app_type){
        case 'app':
            if (($ionicHistory.backView() === null || $ionicHistory.backView() === undefined) && $ionicHistory.currentStateName() !== ("app." + home_template)) {
                $ionicHistory.nextViewOptions({
                    disableBack: true
                });
                $ionicHistory.clearHistory();
                $state.go('app.' + home_template, {id: home_id});
                $ionicHistory.clearHistory();

            }
            else if ($ionicHistory.currentStateName() === ("app." + home_template)) {
                $scope.showExitConfirmation = function () {
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Exit Application',
                        css: 'cp-button',
                        template: "<div style='display:flex;justify-content:center;align-items:center;'>Are you sure want to exit?</div>",
                        okType: 'cp-button'
                    });

                    //confirmation dialog
                    confirmPopup.then(function (res) {
                        if (res) {
                            ionic.Platform.exitApp();
                        }
                    });
                };

                $scope.showExitConfirmation();
            }
            else {
                $ionicHistory.goBack();
            }
            break;
        case 'studio':
            if (($ionicHistory.backView() === null || $ionicHistory.backView() === undefined) && $ionicHistory.currentStateName() !== ("app." + home_template)) {
                $ionicHistory.nextViewOptions({
                    disableBack: true
                });
                $ionicHistory.clearHistory();
                $state.go('app.' + home_template, {id: home_id});
                $ionicHistory.clearHistory();
            }
            else if ($ionicHistory.currentStateName() === ("app." + home_template)) {
                $ionicHistory.clearHistory();
                $scope.showExitConfirmation = function () {
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Exit Preview',
                        css: 'cp-button',
                        template: "<div style='display:flex;justify-content:center;align-items:center;'>Are you sure want to exit preview?</div>",
                        okType: 'cp-button'
                    });

                    //confirmation dialog
                    confirmPopup.then(function (res) {
                        if (res) {
                            $scope.backToAppList();
                        }
                    });
                };

                $scope.showExitConfirmation();
            }
            else 
                $ionicHistory.goBack();
            break;
        }
        //console.log($ionicHistory.backView());
    };

    // override back button
    doregisterHardBack = $ionicPlatform.registerBackButtonAction(doCustomBack, 101);

    $scope.clearHistory = function () {
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $ionicHistory.clearCache();
        $ionicHistory.clearHistory();
    };

    $scope.$on('$destroy', function () {
        doregisterHardBack();
    });

    $scope.$on('SQLite:getOfflineMenuSuccess', function () {
        //console.log($scope.data);
        main_menu = $scope.data.terms;
        console.log("GET MENU SUCCESS");
        //console.log(main_menu);

        var login_enabled = getPostMetaValueById($scope.data.options, "login_enabled");
        isLoginEnabled = login_enabled !== undefined ? (login_enabled.value == 'YES' ? true : false) : false;
        
        register_phone_required = getPostMetaValueById($scope.data.options, "register_phone_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_phone_required").value : 'NO';        
        register_address_required = getPostMetaValueById($scope.data.options, "register_address_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_address_required").value : 'NO';
        register_message_required = getPostMetaValueById($scope.data.options, "register_message_required") !== undefined ? getPostMetaValueById($scope.data.options, "register_message_required").value : 'NO';

        audioDownloadEnabled = getPostMetaValueById($scope.data.options, "audio_download_enabled")!== undefined ? (getPostMetaValueById($scope.data.options, "audio_download_enabled").value == 'YES' ? true : false) : false;

        canAttendEvent = getPostMetaValueById($scope.data.options, "can_attend_event") !== undefined ? (getPostMetaValueById($scope.data.options, "can_attend_event").value == 'YES' ? true : false):false;

        home_share_apps = getPostMetaValueById($scope.data.options, "home_share_apps") !== undefined ? (getPostMetaValueById($scope.data.options, "home_share_apps").value == 'YES' ? true : false):false;

        isDeviceLogin = getPostMetaValueById($scope.data.options, "is_device_login") !== undefined ? (getPostMetaValueById($scope.data.options, "is_device_login").value == 'YES' ? true : false):false;

        shopping_enabled = getPostMetaValueById($scope.data.options, "shopping_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "shopping_enabled").value == 'YES' ? true : false):false;
        
        currency = getPostMetaValueById($scope.data.options, "price_currency") !== undefined ? getPostMetaValueById($scope.data.options, "price_currency").value : 'Rp';
        
        stock_status_visible = getPostMetaValueById($scope.data.options, "stock_status_visible") !== undefined ? getPostMetaValueById($scope.data.options, "stock_status_visible").value : 'NO';
        
        booking_enabled = getPostMetaValueById($scope.data.options, "booking_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "booking_enabled").value == 'YES' ? true : false):false;
        
        playstore_link = getPostMetaValueById($scope.data.options, "link_playstore") !== undefined ? getPostMetaValueById($scope.data.options, "link_playstore").value : '';
        
        appstore_link = getPostMetaValueById($scope.data.options, "link_appstore") !== undefined ? getPostMetaValueById($scope.data.options, "link_appstore").value : '';
        
        inAppPurchaseEnabled = getPostMetaValueById($scope.data.options, "in_app_purchase_enabled") !== undefined ? (getPostMetaValueById($scope.data.options, "in_app_purchase_enabled").value == 'YES' ? true : false):false;
        
        is_membership_enabled = getPostMetaValueById($scope.data.options, "is_membership_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "is_membership_enabled").value : 'NO';
        
        membership_product_data_android = getPostMetaValueById($scope.data.options, "membership_product_data_android");
        membership_product_data_android = JSON.parse(membership_product_data_android !== undefined ? membership_product_data_android.value : "[]");
        
        custom_register_fields  = getPostMetaValueById($scope.data.options, "custom_register_fields") !== undefined ? getPostMetaValueById($scope.data.options, "custom_register_fields").value : false;
        default_register_fields  = getPostMetaValueById($scope.data.options, "default_register_fields") !== undefined ? getPostMetaValueById($scope.data.options, "default_register_fields").value : false;

        custom_transaction_fields  = getPostMetaValueById($scope.data.options, "custom_transaction_fields") !== undefined ? getPostMetaValueById($scope.data.options, "custom_transaction_fields").value : false;
        default_transaction_fields  = getPostMetaValueById($scope.data.options, "default_transaction_fields") !== undefined ? getPostMetaValueById($scope.data.options, "default_transaction_fields").value : false;        

        vt_payment_service = getPostMetaValueById($scope.data.options, "vt_payment_service") !== undefined ? getPostMetaValueById($scope.data.options, "vt_payment_service").value : 'NO';
        $rootScope.manual_payment = vt_payment_service=='YES' ? false : true;
        
        rajaongkir_enabled = getPostMetaValueById($scope.data.options, "rajaongkir_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_enabled").value : 'NO';
        sicepat_enabled = getPostMetaValueById($scope.data.options, "sicepat_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "sicepat_enabled").value : 'NO';

        rajaongkir_sender_city_id = getPostMetaValueById($scope.data.options, "rajaongkir_sender_city_id") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_sender_city_id").value : '152';
        sicepat_origin = getPostMetaValueById($scope.data.options, "sicepat_origin") !== undefined ? getPostMetaValueById($scope.data.options, "sicepat_origin").value : 'CGK';

        rajaongkir_selected_services = getPostMetaValueById($scope.data.options, "rajaongkir_selected_services") !== undefined ? getPostMetaValueById($scope.data.options, "rajaongkir_selected_services").value : '';

        maintenance_enabled = getPostMetaValueById($scope.data.options, "maintenance_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "maintenance_enabled").value : 'NO';
        
        $rootScope.jne_service = getPostMetaValueById($scope.data.options, "jne_service") !== undefined ? getPostMetaValueById($scope.data.options, "jne_service").value : 'NO';
        
        sku_enabled = getPostMetaValueById($scope.data.options, "sku_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "sku_enabled").value : 'NO';

        default_menu_titles =  getPostMetaValueById($scope.data.options, "default_menu_titles") !== undefined ? getPostMetaValueById($scope.data.options, "default_menu_titles").value : false;
        
        if(default_menu_titles!=false)
        {
            default_menu_titles = JSON.parse(default_menu_titles);
            console.log(default_menu_titles);
            
            menu_text_login = default_menu_titles.login !== undefined && default_menu_titles.login[language]!==undefined ? default_menu_titles.login[language] : "Login";
            
            menu_text_user = default_menu_titles.user !== undefined && default_menu_titles.user[language]!==undefined ? default_menu_titles.user[language] : "User";
            
            menu_text_notif = default_menu_titles.notification !== undefined && default_menu_titles.notification[language]!==undefined ? default_menu_titles.notification[language] : "Notification List";
            
            menu_text_cart = default_menu_titles.cart !== undefined && default_menu_titles.cart[language]!==undefined ? default_menu_titles.cart[language] : "Shopping Cart";
            
            menu_text_search = default_menu_titles.search !== undefined && default_menu_titles.search[language]!==undefined ? default_menu_titles.search[language] : "Search";
            
            menu_text_share = default_menu_titles.share !== undefined && default_menu_titles.share[language]!==undefined ? default_menu_titles.share[language] : "Share Apps";
            $scope.menu_text_share = menu_text_share;
            
            console.log("==========================================================");
            console.log(default_menu_titles.search[language])
            console.log("==========================================================");
            
            if(login_menu=="Login") login_menu = menu_text_login;
            else if(login_menu="User") login_menu = menu_text_user;
        }
        else
        {
            menu_text_login = "Login";
            menu_text_user = "User";
            menu_text_notif = "Notification List";
            menu_text_cart = "Shopping Cart";
            menu_text_search = "Search";
            menu_text_share = "Share Apps";
        }
        
        ui_texts_products =  getPostMetaValueById($scope.data.options, "ui_texts_products") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_products").value : false;
        
        if(ui_texts_products!=false)
        {
            ui_texts_products = JSON.parse(ui_texts_products);
        }
        
        ui_texts_events =  getPostMetaValueById($scope.data.options, "ui_texts_events") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_events").value : false;
        
        if(ui_texts_events!=false)
        {
            ui_texts_events = JSON.parse(ui_texts_events);
        }
        
        ui_texts_bookings =  getPostMetaValueById($scope.data.options, "ui_texts_bookings") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_bookings").value : false;
        
        if(ui_texts_bookings!=false)
        {
            ui_texts_bookings = JSON.parse(ui_texts_bookings);
        }
        
        ui_texts_careers =  getPostMetaValueById($scope.data.options, "ui_texts_careers") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_careers").value : false;
        
        if(ui_texts_careers!=false)
        {
            ui_texts_careers = JSON.parse(ui_texts_careers);
        }
        
        ui_texts_audios =  getPostMetaValueById($scope.data.options, "ui_texts_audios") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_audios").value : false;
        
        if(ui_texts_audios!=false)
        {
            ui_texts_audios = JSON.parse(ui_texts_audios);
        }
        
        ui_texts_custom_forms =  getPostMetaValueById($scope.data.options, "ui_texts_custom_forms") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_custom_forms").value : false;
        
        if(ui_texts_custom_forms!=false)
        {
            ui_texts_custom_forms = JSON.parse(ui_texts_custom_forms);
        }
        
        ui_texts_files =  getPostMetaValueById($scope.data.options, "ui_texts_files") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_files").value : false;
        
        if(ui_texts_files!=false)
        {
            ui_texts_files = JSON.parse(ui_texts_files);
        }
        
        ui_texts_webviews =  getPostMetaValueById($scope.data.options, "ui_texts_webviews") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_webviews").value : false;
        
        if(ui_texts_webviews!=false)
        {
            ui_texts_webviews = JSON.parse(ui_texts_webviews);
        }
        
        ui_texts_contacts =  getPostMetaValueById($scope.data.options, "ui_texts_contacts") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_contacts").value : false;
        
        if(ui_texts_contacts!=false)
        {
            ui_texts_contacts = JSON.parse(ui_texts_contacts);
        }
        
        ui_texts_contact_forms =  getPostMetaValueById($scope.data.options, "ui_texts_contact_forms") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_contact_forms").value : false;
        
        if(ui_texts_contact_forms!=false)
        {
            ui_texts_contact_forms = JSON.parse(ui_texts_contact_forms);
        }
        
        ui_texts_transactions =  getPostMetaValueById($scope.data.options, "ui_texts_transactions") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_transactions").value : false;
        
        if(ui_texts_transactions!=false)
        {
            ui_texts_transactions = JSON.parse(ui_texts_transactions);
        }
        
        ui_texts_manual_payments =  getPostMetaValueById($scope.data.options, "ui_texts_manual_payments") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_manual_payments").value : false;
        
        if(ui_texts_manual_payments!=false)
        {
            ui_texts_manual_payments = JSON.parse(ui_texts_manual_payments);
        }
        
        ui_texts_shopping_cart =  getPostMetaValueById($scope.data.options, "ui_texts_shopping_cart") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_shopping_cart").value : false;
        
        if(ui_texts_shopping_cart!=false)
        {
            ui_texts_shopping_cart = JSON.parse(ui_texts_shopping_cart);
        }
        
        ui_texts_register =  getPostMetaValueById($scope.data.options, "ui_texts_register") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_register").value : false;
        
        if(ui_texts_register!=false)
        {
            ui_texts_register = JSON.parse(ui_texts_register);
        }
        
        ui_texts_login =  getPostMetaValueById($scope.data.options, "ui_texts_login") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_login").value : false;
        
        if(ui_texts_login!=false)
        {
            ui_texts_login = JSON.parse(ui_texts_login);
        }
        
        ui_texts_general =  getPostMetaValueById($scope.data.options, "ui_texts_general") !== undefined ? getPostMetaValueById($scope.data.options, "ui_texts_general").value : false;
        
        if(ui_texts_general!=false)
        {
            ui_texts_general = JSON.parse(ui_texts_general);
        }
        
        custom_feedback_message =  getPostMetaValueById($scope.data.options, "custom_feedback_message") !== undefined ? getPostMetaValueById($scope.data.options, "custom_feedback_message").value : false;
        
        manual_payment_method_list =  getPostMetaValueById($scope.data.options, "manual_payment_method_list") !== undefined ? getPostMetaValueById($scope.data.options, "manual_payment_method_list").value : false;
        
        manual_payment_instruction =  getPostMetaValueById($scope.data.options, "manual_payment_instruction") !== undefined ? getPostMetaValueById($scope.data.options, "manual_payment_instruction").value : '1. Please transfer the required amount from an ATM or mobile banking to one of the accounts below.  <br/><br/>2. Tap "Take Photo" to take the picture of receipt with your phone camera, or "Choose Photo" to take the picture from gallery.<br/><br/>  3. The picture will be uploaded, the our admin will process your transaction*.<br/><br/><br/>    * Please note that invalid transaction receipt will be ignored.';
        
        shopping_tnc =  getPostMetaValueById($scope.data.options, "shopping_tnc") !== undefined ? getPostMetaValueById($scope.data.options, "shopping_tnc").value : "Terms and condition dalam transaksi penjualan utk Compro<br/><br/>1. Kebijakan utk customer jika barang yang diterima tidak sesuai dg permintaan yg telah disepakati antara pihak penjual (Compro) dan customer. Kami selaku pihak penjual akan menjamin jika barang yg diterima oleh customer tidak sesuai dengan kriteria dan ksepakatan maka kami siap untuk mengganti barang tersebut 100% sesuai dg kriteria yg disepakati dalam proses jual beli barang dg syarat Batas waktu utk complain barang adalah maks 7 hari setelah barang diterima oleh customer. <br/><br/>2. Kebijakan utk customer jika barang tidak terkirim atau customer tidak menerima barang yang dipesan maka Kami selaku pihak penjual akan mengirim ulang kembali barang tsb dan menjamin 100%  barang dapat diterima oleh customer. Pihak customer diwajibkan utk mengisi alamat pengiriman dengan lengkap dan jelas. Batas waktu utk complain barang tdk sampai adalah maks 12 hari setelah customer melakukan pembayaran";
        
        tax_enabled = getPostMetaValueById($scope.data.options, "tax_enabled") !== undefined ? getPostMetaValueById($scope.data.options, "tax_enabled").value :"NO";
        
        custom_tax_fields  = getPostMetaValueById($scope.data.options, "custom_tax_fields") !== undefined ? getPostMetaValueById($scope.data.options, "custom_tax_fields").value : false;

        $scope.main_menu_post = $scope.data;
        //console.log($scope.main_menu_post);
        $scope.main_menu = main_menu;
        $scope.login_enabled = login_enabled.value;
        $scope.login_required = login_required.value;
        $scope.shopping_enabled = shopping_enabled.value;
        $scope.menu_type = menu_type;
        $scope.menu_template = menu_template;
        $scope.tab_type = tab_type;
        $scope.isloading = false;
        $scope.rajaongkir_enabled = rajaongkir_enabled;
        $scope.sicepat_enabled = sicepat_enabled;
    });

    // Create the menu modal that we will use later
    $ionicModal.fromTemplateUrl('templates/tabs-more-modal-1.html', {
        scope: $scope
    }).then(function (modal) {
        $scope.modal = modal;
        //success
    }, {
        //error
    });

    // Triggered in the menu modal to close it
    $scope.closeMenu = function () {
        $scope.modal.hide();
    };

    // Open the menu modal
    $scope.openMenu = function () {
        $scope.modal.show();
    };

    $scope.openDrawer = function (modalTemplateURL) {
        // Create the menu modal that we will use later
        if ($scope.modal == undefined) {
            $ionicModal.fromTemplateUrl(modalTemplateURL, {
                scope: $scope
            }).then(function (modal) {
                $scope.modal = modal;
                //success
                $scope.openMenu();
            }, {
                //error
            });
        }
        else if (modalTemplateURL !== "")
            $ionicModal.fromTemplateUrl(modalTemplateURL, {
                scope: $scope
            }).then(function (modal) {
                $scope.modal = modal;
                //success
                $scope.openMenu();
            }, {
                //error
            });
        else
            $scope.openMenu();
    };

    $scope.setActiveMenu = function ($index) {
        $scope.selected_menu = $index;
    };

    $scope.$on('httpService:postTokenPushNotifSuccess', function () {
        token = $scope.data.token;
        //console.log(token);
        // upload registration_id, device_id, dan company_id to server.
        console.log('Register data to server...');
        var url = base_url + register_push_notif_url;
        var device_type = isIOS() ? 'ios' : 'android';
        var objPushNotif = serializeData({
            registration_id: registration_id,
            device_id: device_id,
            device_type: device_type,
            company_id: company_id,
            token: token
        });
        $scope.registerPushResult = httpService.post($scope, $http, url, objPushNotif, 'push_notif');
        //console.log($scope.registerPushResult);
    });

    $scope.$on('httpService:postTokenPushNotifError', function () {
        if ($scope.status === 0) {
            console.log('NO INTERNET CONNECTION');
        }
        else {
            var url = token_url;
            var obj = serializeData({email: username, password: password, company_id: company_id});
            httpService.post_token($scope, $http, url, obj, 'push_notif');
        }
    });

    $scope.$on('httpService:postRegisterPushNotifSuccess', function () {
        console.log('Register Push Notif SUCCESS!');
    });

    $scope.$on('httpService:postRegisterPushNotifError', function () {
        console.log('Register Push Notif ERROR!');
    });

    $scope.socialShare = function () {
        if (isPhoneGap()) {
            if (isAndroid()) {
                socialShare($cordovaClipboard, $cordovaToast, $timeout, "Download the app at:", null, null, playstore_link, null);
            }
            else if (isIOS()) {
                socialShare($cordovaClipboard, $cordovaToast, $timeout, 'Download the app at:', null, null, appstore_link, null);
            }
        } else {
            console.log('Social Share: Not a Mobile Device');
            console.log(playstore_link);
            console.log(appstore_link);
        }
    };

    $rootScope.$on("$cordovaLocalNotification:click", function (notification, state) {
        var data = JSON.parse(state.data);
        //console.log('test pencet notif');
        //console.log(data.additionalData.target);
        window.location.href = "#/app/" + data.additionalData.target;
    });

    $scope.login_menu = login_menu;
    

    // Triggered in the menu modal to close it
    $scope.closeZoombleImageModal = function () {
        $scope.ZoombleImageModal.hide();
    };

    // Open the menu modal
    $scope.openZoombleImageModal = function () {
        $scope.ZoombleImageModal.show();
    };

    $scope.openZoombleImage = function (modalTemplateURL) {
        // Create the menu modal that we will use later
        if ($scope.ZoombleImageModal == undefined) {
            $ionicModal.fromTemplateUrl(modalTemplateURL, {
                scope: $scope
            }).then(function (modal) {
                $scope.ZoombleImageModal = modal;
                //success
                $scope.openZoombleImageModal();
            }, {
                //error
            });
        }
        else if (modalTemplateURL !== "")
            $ionicModal.fromTemplateUrl(modalTemplateURL, {
                scope: $scope
            }).then(function (modal) {
                $scope.ZoombleImageModal = modal;
                //success
                $scope.openZoombleImageModal();
            }, {
                //error
            });
        else
            $scope.openZoombleImageModal();
    };

    $scope.showLoginToCommentAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Checkout',
            template: '<div style="width:100%;text-align:center">Please login first before posting a comment</div>',
            buttons:[
                {
                    text: 'OK'
                },
                {
                    text: 'Login',
                    type: 'cp-button',
                    onTap: function(e)
                    {
                        $rootScope.login_redirect_location = '#'+$ionicHistory.currentView().url;
                        window.location.href= "#/app/login/-1" ;
                    }
                }
            ]
        });
    };
    

    // show confirmation modal for external link
    document.onclick = function (e) {
        e = e || window.event;
        var element = e.target || e.srcElement;
        if (element.tagName == 'A' && element.classList.contains('external-link')) {
            //window.open(element.href, "_blank", "location=yes");
            showExternalLinkConfirmation($cordovaClipboard, $cordovaToast, $ionicPopup, element.href);
            return false; // prevent default action and stop event propagation
        }

        if (element.tagName == 'IMG' && element.classList.contains('image-zoomable')) {
            console.log('Zoom Image');
            //console.log(element.src);
            $scope.zoomable_image = element.src;
            $scope.openZoombleImage("templates/zoomable-image-modal-1.html");
            return;
        }
    };
    
    var doStudioBack = function () {
//        console.log("*** Back Studio Controller ***");
        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        $scope.clearHistory();
        $scope.showExitConfirmation = function () {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Exit Application',
                css: 'cp-button',
                template: "<div style='display:flex;justify-content:center;align-items:center;'>Are you sure want to exit?</div>",
                okType:'cp-button'
            });

            //confirmation dialog
            confirmPopup.then(function (res) {
                if (res) {
                    ionic.Platform.exitApp();
                }
                else {
                    doregisterHardBack = $ionicPlatform.registerBackButtonAction(doStudioBack, 101);
                }
            });
        };
        
        $scope.showExitConfirmation();
    };
    
    $scope.backToAppList = function(){
        $ionicHistory.clearHistory();
        st_preview_app = false;
        doregisterHardBack = $ionicPlatform.registerBackButtonAction(doStudioBack, 101);
        $state.go('studio.app-list');
//        window.location.href = '#/studio/studio-app-list';
    }
    
    $rootScope.customSocialShare = function (title, summary) {
        if (isPhoneGap()) {
            if (isAndroid()) {
                socialShare($cordovaClipboard, $cordovaToast, $timeout, summary, title, null, playstore_link, 'Read more at');
            }
            else if (isIOS()) {
                socialShare($cordovaClipboard, $cordovaToast, $timeout, summary, title, null, appstore_link, 'Read more at');
            }
        } else {
            console.log('Social Share: Not a Mobile Device');
            console.log(summary);
            console.log(title);
            console.log(playstore_link);
            console.log(appstore_link);
        }
    };
});
