app.controller("ShoppingCartCtrl", function ($scope, $rootScope, $http, httpService, $stateParams, $ionicLoading, $ionicPopup, $ionicPlatform) {

    var payment_url = 'payment_url';
    $scope.provinces = [];
    $scope.cities = [];
    $scope.costs = [];
    $scope.tariff = {};
    $scope.tariff.selectedProvince = '';
    $scope.tariff.selectedCity = '';
    $scope.tariff.selectedService = '';
    $scope.tariff.selectedCost = 'null;0';
    $scope.cost_value = 0;
    $scope.finalTotal = 0;
    $scope.deliveryPrice = 0;
    $scope.deliveryCourier = '';
    $scope.deliveryMethod = '';
    $scope.courier_available = false;

    $scope.costsSicepat = [];
    $scope.sicepat = [];
    $scope.sicepat_city = [];
    $scope.tariff.selectedProvinceSicepat = '';
    $scope.tariff.selectedCitySicepat = '';
    $scope.tariff.selectedSubdistrictSicepat = '';
    
    var currentRajaOngkirLoad = '';
    
    $ionicPlatform.ready(function () {
        if(user_id != '')
        {   
            $scope.isLogin = true;
            $scope.input = {
                name: username_login,
                email: email,
                phone: phone,
                address: address,
                comments:'',
                meta: user_meta
            };
        }
        else {
            $scope.isLogin = false;
            $scope.input = {
                name: '',
                email: '',
                phone: '',
                address:'',
                comments:'',
                meta: ''
            };
        }

        $scope.custom_transaction_fields = JSON.parse(custom_transaction_fields);
        $scope.default_transaction_fields = JSON.parse(default_transaction_fields)[0];
        
        $scope.unavailable_product = [];
        // $scope.rajaongkir_enabled = "YES";
        // $scope.sicepat_enabled ="YES";
        if(rajaongkir_selected_services!='')
            $scope.rajaongkir_selected_services = JSON.parse(rajaongkir_selected_services);
        else
            $scope.rajaongkir_selected_services = JSON.parse('{"jne":true,"tiki":true,"pos":true}');
        
        $scope.tax_enabled = tax_enabled;
        
        if(custom_tax_fields!=false)
        {
            $scope.custom_tax_fields = JSON.parse(custom_tax_fields);
        }
        else
        {
            $scope.custom_tax_fields = JSON.parse("[]");
        }
        
        var loadCustomText = function () {
            
            $scope.title = "Shopping Cart";
            $scope.items_in_cart = "Items in Cart";
            $scope.remove_item_hint = "Swipe left to remove item";
            $scope.button_text_checkout = "Checkout";
            $scope.no_cart_item = "No Item in Shopping Cart";
            
            $scope.text_volumetric_weight = "Volumetric Weight";
            $scope.text_rajaongkir_province = "Province";
            $scope.text_rajaongkir_city = "City";
            $scope.text_rajaongkir_service = "Service";
            $scope.text_rajaongkir_select_province = "SELECT PROVINCE";
            $scope.text_rajaongkir_select_city = "SELECT CITY";
            $scope.text_rajaongkir_select_service = "SELECT SERVICE";
            $scope.text_rajaongkir_total_ongkir = "Total + Ongkir";
            $scope.button_text_rajaongkir_check_cost = "Check Cost";
            $scope.text_tnc_agree = "By clicking this button below, you have accepted our";
            $scope.text_view_tnc = "Terms and Conditions";
            $scope.text_tnc_agree_alert = "you must agree to terms and conditions";
            
            // not updated yet on CMS
            $scope.text_no_cost_found_alert = "No delivery service available to your area.";
            $scope.text_check_cost_alert = "Please select courier, province, and city.";
            $scope.text_login_alert = "Please login first before checkout";
            $scope.text_success_alert = "Your Order Submitted Successfully";
            $scope.text_failed_alert = "Failed to Submit Your Order. Make sure You have the item(s) you want to order and check your internet connection.";
            $scope.text_delivery_alert = "Please choose delivery method";
            
            $scope.title = default_menu_titles.cart !== undefined && default_menu_titles.cart[language]!==undefined ? default_menu_titles.cart[language] : "Shopping Cart";

            $scope.items_in_cart = default_menu_titles.items_in_cart !== undefined && default_menu_titles.items_in_cart[language]!==undefined ? default_menu_titles.items_in_cart[language] : "Items in Cart";

            $scope.remove_item_hint  = default_menu_titles.remove_item_hint !== undefined && default_menu_titles.remove_item_hint[language]!==undefined ? default_menu_titles.remove_item_hint[language] : "swipe left to remove item";

            $scope.button_text_checkout = default_menu_titles.button_text_checkout !== undefined && default_menu_titles.button_text_checkout[language]!==undefined ? default_menu_titles.button_text_checkout[language] : "Checkout";

            $scope.no_cart_item = default_menu_titles.no_cart_item !== undefined && default_menu_titles.no_cart_item[language]!==undefined ? default_menu_titles.no_cart_item[language] : "No Item in Shopping Cart";

            $scope.text_volumetric_weight = ui_texts_shopping_cart.text_volumetric_weight !== undefined && ui_texts_shopping_cart.text_volumetric_weight[language]!==undefined ? ui_texts_shopping_cart.text_volumetric_weight[language] : "Volumetric Weight";

            $scope.text_rajaongkir_province = ui_texts_shopping_cart.text_rajaongkir_province !== undefined && ui_texts_shopping_cart.text_rajaongkir_province[language]!==undefined ? ui_texts_shopping_cart.text_rajaongkir_province[language] : "Province";

            $scope.text_rajaongkir_city = ui_texts_shopping_cart.text_rajaongkir_city !== undefined && ui_texts_shopping_cart.text_rajaongkir_city[language]!==undefined ? ui_texts_shopping_cart.text_rajaongkir_city[language] : "City";

            $scope.text_rajaongkir_service = ui_texts_shopping_cart.text_rajaongkir_service !== undefined && ui_texts_shopping_cart.text_rajaongkir_service[language]!==undefined ? ui_texts_shopping_cart.text_rajaongkir_service[language] : "Service";

            $scope.text_rajaongkir_select_province = ui_texts_shopping_cart.text_rajaongkir_select_province !== undefined && ui_texts_shopping_cart.text_rajaongkir_select_province[language]!==undefined ? ui_texts_shopping_cart.text_rajaongkir_select_province[language] : "SELECT PROVINCE";

            $scope.text_rajaongkir_select_city = ui_texts_shopping_cart.text_rajaongkir_select_city !== undefined && ui_texts_shopping_cart.text_rajaongkir_select_city[language]!==undefined ? ui_texts_shopping_cart.text_rajaongkir_select_city[language] : "SELECT CITY";

            $scope.text_rajaongkir_select_service = ui_texts_shopping_cart.text_rajaongkir_select_service !== undefined && ui_texts_shopping_cart.text_rajaongkir_select_service[language]!==undefined ? ui_texts_shopping_cart.text_rajaongkir_select_service[language] : "SELECT SERVICE";

            $scope.text_rajaongkir_total_ongkir = ui_texts_shopping_cart.text_rajaongkir_total_ongkir !== undefined && ui_texts_shopping_cart.text_rajaongkir_total_ongkir[language]!==undefined ? ui_texts_shopping_cart.text_rajaongkir_total_ongkir[language] : "Total + Ongkir";

            $scope.button_text_rajaongkir_check_cost = ui_texts_shopping_cart.button_text_rajaongkir_check_cost !== undefined && ui_texts_shopping_cart.button_text_rajaongkir_check_cost[language]!==undefined ? ui_texts_shopping_cart.button_text_rajaongkir_check_cost[language] : "Check Cost";

            $scope.text_tnc_agree = ui_texts_shopping_cart.text_tnc_agree !== undefined && ui_texts_shopping_cart.text_tnc_agree[language]!==undefined ? ui_texts_shopping_cart.text_tnc_agree[language] : $scope.text_tnc_agree;
            
            $scope.text_tnc_agree_alert = ui_texts_shopping_cart.text_tnc_agree_alert !== undefined && ui_texts_shopping_cart.text_tnc_agree_alert[language]!==undefined ? ui_texts_shopping_cart.text_tnc_agree_alert[language] : $scope.text_tnc_agree_alert;
            
            $scope.text_view_tnc = ui_texts_shopping_cart.text_view_tnc !== undefined && ui_texts_shopping_cart.text_view_tnc[language]!==undefined ? ui_texts_shopping_cart.text_view_tnc[language] : $scope.text_view_tnc;
        }
        
        loadCustomText();

        $scope.shoppingCarts = shoppingCharts;

        $scope.currency = currency + ' ';
        //console.log("currency : " + $scope.currency );
        //console.log(shoppingCharts.length);
        $scope.totalPrice = 0;
        $scope.totalQty = 0;
        $scope.totalWeight = 0;


        $scope.calculateWeight = function()
        {
            if(shoppingCharts.length > 0) {
                $scope.totalWeight = 0;
                $scope.totalPrice = 0;
                for (var i = 0; i < shoppingCharts.length; i++) {
                    $scope.totalPrice += (shoppingCharts[i].price * shoppingCharts[i].qty);
                    $scope.totalQty += shoppingCharts[i].qty;
                    var max_weight_value = 0;
                        
                    var itemVolumeValue = parseFloat(shoppingCharts[i].volume.value == undefined ? 1 : shoppingCharts[i].volume.value);
                    var itemWeightValue = parseFloat(shoppingCharts[i].weight.value == undefined ? 1 : shoppingCharts[i].weight.value);
                    
                    var volumetricWeight = (itemVolumeValue / 6000 * 1000);
                    var itemWeight = itemWeightValue;
                    
                    console.log(volumetricWeight);
                    console.log(itemWeight);
                    
                    max_weight_value = itemWeight > volumetricWeight ? itemWeight : volumetricWeight;
                                            
                    console.log(max_weight_value);
                    console.log(shoppingCharts[i].qty);
                    
                    $scope.totalWeight += max_weight_value  * shoppingCharts[i].qty;
                    console.log("TOTAL WEIGHT " + i);
                    console.log($scope.totalWeight);
                }
            }
            else {
                $scope.totalWeight = 0;
            }
            console.log($scope.totalWeight);
            $scope.totalWeight = (parseFloat($scope.totalWeight)).toFixed(2);
            console.log($scope.totalWeight);

        }
        $scope.calculateWeight();
        $rootScope.totalQty = $scope.totalQty;

        //calculating taxes
        $scope.subTotal = $scope.totalPrice;
        $scope.taxes = new Array();
        if($scope.tax_enabled == 'YES')
        {
            var previous_order_number = 0;
            var previous_total_value = $scope.totalPrice;
            for (var i = 0; i < $scope.custom_tax_fields.length; i++) {
                if($scope.custom_tax_fields[i].order_no != previous_order_number)
                {
                    previous_order_number = $scope.custom_tax_fields[i].order_no;
                    previous_total_value = $scope.totalPrice;
                }
                
                $scope.taxes[i]= JSON.parse('{"label":"","value":0}');
                
                $scope.taxes[i].label = $scope.custom_tax_fields[i].field_name;
                if($scope.custom_tax_fields[i].value_type=="percentage"){
                    $scope.taxes[i].value = previous_total_value * $scope.custom_tax_fields[i].value/100;
                }
                else if($scope.custom_tax_fields[i].value_type=="sum"){
                    $scope.taxes[i].value = parseInt($scope.custom_tax_fields[i].value);
                }
                
                $scope.totalPrice += $scope.taxes[i].value;
                
                console.log(previous_order_number);
                console.log(previous_total_value);
                
            }
        }
        
        console.log($scope.taxes);
        
        $scope.shouldShowDelete = false;
        $scope.shouldShowReorder = false;
        $scope.listCanSwipe = true;
        $scope.onItemDelete = function (index, id) {
            shoppingCharts.splice(index, 1);
            if(isPhoneGap()) clearCartById(id);
            $scope.totalPrice = 0;
            $scope.totalQty = 0;
            for (var i = 0; i < shoppingCharts.length; i++) {
                $scope.totalPrice += (shoppingCharts[i].price * shoppingCharts[i].qty);
                $scope.totalQty += shoppingCharts[i].qty;
            }
            $rootScope.totalQty = $scope.totalQty;
            console.log("MASUK");
            $scope.recalculateTotal();
            $scope.calculateWeight();
        };
        

        //comment this
        if(rajaongkir_enabled == 'YES'){
            $scope.finalTotal = $scope.totalPrice;
            url = raja_ongkir_province + '0';
            httpService.get($scope, $http, url, 'rajaongkir-province', token);
        }

        if(sicepat_enabled == 'YES'){
            url = sicepat_province;
            httpService.get($scope, $http, url, 'sicepat-province', token);
        }
    });

    $scope.$on('httpService:getRajaOngkirProvinceSuccess', function () {
        $scope.hideLoading();
        $scope.provinces = $scope.data.rajaongkir.results;
        //url = raja_ongkir_city + '0/' + $scope.tariff.selectedProvince;
        //httpService.get($scope, $http, url, 'rajaongkir-city', token)
        $scope.isLoading = false;
        $scope.$broadcast('scroll.refreshComplete');
    });

    $scope.$on('httpService:getSicepatProvinceSuccess', function () {
        $scope.hideLoading();
        $scope.provincesSicepat = $scope.data.sicepat;
        $scope.isLoading = false;
        $scope.$broadcast('scroll.refreshComplete');
    });

    // if get data list article error, request token again
    $scope.$on('httpService:getRajaOngkirProvinceError', function () {
        url = raja_ongkir_province + '0';
        httpService.get($scope, $http, url, 'rajaongkir-province', token);
    });

    // if get data list article error, request token again
    $scope.$on('httpService:getSicepatProvinceError', function () {
        url = sicepat_province;
        httpService.get($scope, $http, url, 'sicepat-province', token);
    });

    $scope.$on('httpService:getRajaOngkirCitySuccess', function () {
        $scope.hideLoading();
        $scope.cities = $scope.data.rajaongkir.results;
        //$scope.tariff.selectedCity = $scope.data.rajaongkir.results[0].city_id;
        $scope.isLoading = false;
        $scope.$broadcast('scroll.refreshComplete');
    });

    // if get data list article error, request token again
    $scope.$on('httpService:getRajaOngkirCityError', function () {
        url = raja_ongkir_city + '0/'+ $scope.tariff.selectedProvince;
        httpService.get($scope, $http, url, 'rajaongkir-city', token);
    });

    $scope.$on('httpService:postSicepatDataByProvinceSuccess', function () {
        $scope.hideLoading();
        $scope.sicepat = $scope.data.sicepat;
        $scope.sicepat_city = $scope.data.sicepat_city;
        $scope.isLoading = false;
        $scope.$broadcast('scroll.refreshComplete');
    });

    // if get data list article error, request token again
    $scope.$on('httpService:postSicepatDataByProvinceError', function () {
        url = sicepat_data_by_province + $scope.tariff.selectedProvinceSicepat;
        if($scope.tariff.selectedCitySicepat != '') var obj = serializeData({_method: 'POST', city: $scope.tariff.selectedCitySicepat});
        else var obj = serializeData({_method: 'POST'});
        $scope.result = httpService.post($scope, $http, url, obj, 'sicepat-data-by-province');
    });

    $scope.$on('httpService:getRajaOngkirCostSuccess', function () {
        console.log($scope.data);
        $scope.hideLoading();
        if($scope.data.rajaongkir!=undefined){
            $scope.costs = $scope.data.rajaongkir.results;
            
            if($scope.data.rajaongkir.results[0].costs.length <=0){
                $scope.courier_available = false;
                $scope.showNoCostFoundAlert();
            }
            else $scope.courier_available = true;
        }
        else{
            $scope.courier_available = false;
            $scope.showNoCostFoundAlert();
        }
        $scope.isLoading = false;
        $scope.$broadcast('scroll.refreshComplete');
    });

    // if get data list article error, request token again
    $scope.$on('httpService:getRajaOngkirCostError', function () {
        url = raja_ongkir_cost + $scope.selectCity + '/'+ $scope.selectCity + '/100/jne';
        httpService.get($scope, $http, url, 'rajaongkir-cost', token);
    });
    
    $scope.$on('httpService:postSicepatTariffSuccess', function () {
        console.log($scope.data);
        $scope.hideLoading();
        if($scope.data.sicepat!=undefined){
            $scope.costsSicepat = $scope.data.sicepat;
            
            if($scope.costsSicepat.length <=0){
                $scope.courier_available = false;
                $scope.showNoCostFoundAlert();
            }
            else $scope.courier_available = true;
        }
        else{
            $scope.courier_available = false;
            $scope.showNoCostFoundAlert();
        }
        $scope.isLoading = false;
        $scope.$broadcast('scroll.refreshComplete');
    });

    // if get data list article error, request token again
    $scope.$on('httpService:postSicepatTariffError', function () {
        var origin = sicepat_origin;
        var weight = $scope.totalWeight <=0 ? 0 : $scope.totalWeight;
        var obj = serializeData({_method: 'POST', origin: sicepat_origin, weight: weight, destination: $scope.tariff.selectedSubdistrictSicepat});
        
        url = sicepat_tariff;
        httpService.post($scope, $http, url, obj, 'sicepat-tariff');
    });

    $scope.selectCity = function(city)
    {
        $scope.courier_available = false;
        $scope.tariff.selectedCity = city;
        $scope.tariff.selectedCost = 'null;0';
        $scope.deliveryCourier = 0;
        $scope.finalTotal = parseInt($scope.deliveryCourier) + parseInt($scope.totalPrice);
    }

    $scope.selectSubdistrictSicepat = function(city)
    {
        $scope.courier_available = false;
        $scope.tariff.selectedSubdistrictSicepat = city;
        $scope.tariff.selectedCost = 'null;0';
        $scope.deliveryCourier = 0;
        $scope.finalTotal = parseInt($scope.deliveryCourier) + parseInt($scope.totalPrice);
    }
    
    $scope.selectService = function(service)
    {
        $scope.tariff.selectedService = service;
        $scope.tariff.selectedCost = 'null;0';
        $scope.costs = [];
        $scope.costsSicepat = [];
        // $scope.sicepat = [];
        // $scope.sicepat_city = [];
        // $scope.provinces = [];
        // $scope.provincesSicepat = [];
        // $scope.cities = [];

        $scope.tariff.selectedProvince = [];
        $scope.tariff.selectedCity = [];
        $scope.tariff.selectedProvinceSicepat = {};
        $scope.tariff.selectedCitySicepat = [];
        $scope.tariff.selectedSubdistrictSicepat = [];
        $scope.deliveryCourier = 0;
        $scope.finalTotal = parseInt($scope.deliveryCourier) + parseInt($scope.totalPrice);
    }
    
    $scope.loadProvinceSicepat = function(province)
    {
        $scope.showLoading();
        $scope.tariff.selectedProvince = province;
        $scope.deliveryCourier = 0;
        $scope.finalTotal = parseInt($scope.deliveryCourier) + parseInt($scope.totalPrice);
        console.log(province);
        console.log('selected :'+province);
        //url = raja_ongkir_city + '0/' + province;
    }

    $scope.loadCities = function(province)
    {
        $scope.showLoading();
        $scope.tariff.selectedProvince = province;
        console.log(province);
        console.log('selected :'+province);
        url = raja_ongkir_city + '0/' + province;
        httpService.get($scope, $http, url, 'rajaongkir-city', token);
        $scope.deliveryCourier = 0;
        $scope.finalTotal = parseInt($scope.deliveryCourier) + parseInt($scope.totalPrice);
    }

    $scope.loadCitiesSicepat = function(province)
    {
        $scope.showLoading();
        $scope.courier_available = false;
        $scope.tariff.selectedProvinceSicepat = province;
        console.log(province);
        console.log('selected :'+province);
        $scope.deliveryCourier = 0;
        $scope.finalTotal = parseInt($scope.deliveryCourier) + parseInt($scope.totalPrice);
        url = sicepat_data_by_province + province;
        var obj = serializeData({_method: 'POST'});
        $scope.result = httpService.post($scope, $http, url, obj, 'sicepat-data-by-province');
    }

    $scope.loadSubdistrictSicepat = function(district)
    {
        $scope.showLoading();
        $scope.courier_available = false;
        $scope.deliveryCourier = 0;
        $scope.finalTotal = parseInt($scope.deliveryCourier) + parseInt($scope.totalPrice);
        console.log('selected :'+district);
        url = sicepat_data_by_province + $scope.tariff.selectedProvinceSicepat;
        console.log(url);
        var obj = serializeData({_method: 'POST', city: district});
        console.log(obj);
        $scope.result = httpService.post($scope, $http, url, obj, 'sicepat-data-by-province');
    }
    
    $scope.checkCost = function(province)
    {
        console.log($scope.tariff);
        if($scope.tariff.selectedCity!='' && $scope.tariff.selectedCity!=null && $scope.tariff.selectedService!='' && $scope.tariff.selectedService!=null){
            $scope.showLoading();
            var weight = $scope.totalWeight <=100 ? 100 : $scope.totalWeight;
            currentRajaOngkirLoad = 'check_cost';
            url = raja_ongkir_cost + $scope.tariff.selectedCity + '/'+ rajaongkir_sender_city_id + '/' + weight + '/'+$scope.tariff.selectedService;
            httpService.get($scope, $http, url, 'rajaongkir-cost', token);
        }
        else
        {
            $scope.showCheckCostAlert();
        }
    }
    
    $scope.checkCostSicepat = function(province)
    {
        console.log($scope.tariff);
        if($scope.tariff.selectedSubdistrictSicepat!='' && $scope.tariff.selectedSubdistrictSicepat!=null){
            $scope.showLoading();
            var origin = sicepat_origin;
            var weight = $scope.totalWeight <= 0 ? 1 : $scope.totalWeight / 1000; //totalWeight yang ada dihitung dalam gram.
            console.log(weight);
            var obj = serializeData({_method: 'POST', origin: sicepat_origin, weight: weight, destination: $scope.tariff.selectedSubdistrictSicepat});

            url = sicepat_tariff;
            httpService.post($scope, $http, url, obj, 'sicepat-tariff');
        }
        else
        {
            $scope.showCheckCostAlertSicepat();
        }
    }
    
    $scope.calculateTotal = function(cost)
    {
        courier = cost.split(";")[0];
        method_value = cost.split(";")[1];
        cost_value = cost.split(";")[2];
        $scope.deliveryCourier = courier;
        $scope.deliveryPrice = cost_value;
        $scope.deliveryMethod = method_value;
        $scope.cost_value = parseInt(cost_value);
        $scope.finalTotal = parseInt(cost_value) + parseInt($scope.totalPrice);
    }

    $scope.recalculateTotal = function()
    {
        $scope.finalTotal = parseInt($scope.cost_value) + parseInt($scope.totalPrice);
    }
    
    $scope.showLoginAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Checkout',
            template: '<div style="width:100%;text-align:center">'+ $scope.text_login_alert +'</div>',
            buttons:[
                {
                    text: 'OK'
                },
                {
                    text: 'Login',
                    type: 'cp-button',
                    onTap: function(e)
                    {
                        $rootScope.login_redirect_location = '#/app/shopping-cart-1/-3';
                        window.location.href= "#/app/login/-1" ;
                    }
                }
            ]
        });
    };
    
    $scope.showNoCostFoundAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Checkout',
            template: '<div style="width:100%;text-align:center">'+ $scope.text_no_cost_found_alert +'</div>',
            buttons:[
                {
                    text: 'OK'
                }
            ]
        });
    };
    
    $scope.showCheckCostAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Checkout',
            template: '<div style="width:100%;text-align:center">'+$scope.text_check_cost_alert+'</div>',
            buttons:[
                {
                    text: 'OK'
                }
            ]
        });
    };

    $scope.showCheckCostAlertSicepat = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Checkout',
            template: '<div style="width:100%;text-align:center">Please select courier, province, city and sub district.</div>',
            buttons:[
                {
                    text: 'OK'
                }
            ]
        });
    };
    
    $scope.showDeliveryAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Checkout',
            template: '<div style="width:100%;text-align:center">' + $scope.text_delivery_alert + '</div>',
            buttons:[
                {
                    text: 'OK'
                }
            ]
        });
    };

    $scope.showLoading = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };

    $scope.hideLoading = function () {
        $ionicLoading.hide();
    };

    // function submit comment
    $scope.submitOrder = function () {
        if(!$scope.isLogin) {
            $scope.showLoginAlert();
        }
        else if((rajaongkir_enabled == 'YES' || sicepat_enabled == 'YES') && ($scope.deliveryCourier=='' || $scope.deliveryMethod=='')){
            $scope.showDeliveryAlert();
        }
        else {
            $scope.show();
            var url = token_url;
            var obj = serializeData({email: username, password: password, company_id: company_id});

            // get token for posting comment
            httpService.post_token($scope, $http, url, obj, 'submit_order');
        }
    };

    // if token for post comment success
    $scope.$on('httpService:postTokenSubmitOrderSuccess', function () {
        token = $scope.data.token;
        var ids = new Array();
        var qtys = new Array();
        var input = $scope.input;

        for (var i = 0; i < shoppingCharts.length; i++) {
            ids.push(shoppingCharts[i].id);
            qtys.push(shoppingCharts[i].qty);
        }

        for (var i in input.meta) {
            if (i.indexOf('_date') !== -1) {
                input.meta[i] = new Date(input.meta[i]);
            }
        }
        var obj = serializeData({_method: 'POST', product_ids: ids, qtys : qtys, name: $scope.input.name ,email: $scope.input.email, phone: $scope.input.phone, address: $scope.input.address, comments: $scope.input.comments, meta: JSON.stringify($scope.input.meta), delivery_courier:$scope.deliveryCourier, delivery_method:$scope.deliveryMethod, delivery_price:$scope.deliveryPrice});
        // submit order
        console.log(obj);
        $scope.result = httpService.post($scope, $http, send_email_url + '?token=' + token, obj, 'submit_order');
    });

    // if post comment success, show notification
    $scope.$on('httpService:postSubmitOrderSuccess', function () {
        console.log($scope.result.data.payment_url);
        console.log($scope.result.data.unavailable_product);
        trans_id = $scope.result.data.return_trans_id;
        if ($scope.result.data.success === true) {
            $scope.hide();
            $scope.showSuccessAlert(trans_id);

            shoppingCharts.splice(0,shoppingCharts.length);
            if (isPhoneGap()) {
                clearCart();
            }

            $scope.totalPrice = 0;

            $scope.input = {
                name: '',
                email: '',
                phone: '',
                address:'',
                comments:''
            };

            payment_url = $scope.result.data.payment_url;

        } else {
            $scope.hide();
            if ($scope.result.data.unavailable_product == undefined) $scope.showFailedAlert();
            else if ($scope.result.data.unavailable_product.length == 0) $scope.showFailedAlert(); 
            else {
                $scope.unavailable_product = $scope.result.data.unavailable_product;
                $scope.showUnavailableAlert($scope.unavailable_product);
            }
        }

    });

    $scope.$on('httpService:postSubmitOrderError', function () {
        $scope.hide();
        $scope.showFailedAlert();
    });


    // loading fragment 
    $scope.show = function () {
        $ionicLoading.show({
            template: ionicLoadingTemplate
        });
    };
    $scope.hide = function () {
        $ionicLoading.hide();
    };

    // alert fragment
    $scope.showSuccessAlert = function (trans_id) {
        console.log(trans_id);
        console.log(vt_payment_service);
        if(vt_payment_service == 'YES') {
            var alertPopup = $ionicPopup.alert({
                title: 'Checkout',
                css: 'cp-button',
                okType:'cp-button',
                template: '<div style="width:100%;text-align:center">'+$scope.text_success_alert+'</div>',
                buttons: [
                    {
                        text: 'Pay Later',
                        onTap: function(e)
                        {
                            $rootScope.transaction_count += 1;
                            window.location.href= "#/app/transaction-list" ;
                        }
                    },
                    {
                        text: 'Pay Now',
                        type: 'cp-button',
                        onTap: function(e)
                        {
                            $rootScope.transaction_count += 1;
                            openBrowser(payment_url);
                        }

                    }
                ]
            });
        }
        else {
            var alertPopup = $ionicPopup.alert({
                title: 'Checkout',
                css: 'cp-button',
                okType:'cp-button',
                template: '<div style="width:100%;text-align:center">'+$scope.text_success_alert+'</div>',
                buttons: [
                    {
                        text: 'Pay Later',
                        onTap: function(e)
                        {
                            $rootScope.transaction_count += 1;
                            window.location.href= "#/app/transaction-list" ;
                        }
                    },
                    {
                        text: 'Pay Now',
                        type: 'cp-button',
                        onTap: function(e)
                        {
                            $rootScope.transaction_count += 1;
                            if(trans_id != -1) {
                                window.location.href= "#/app/transaction-detail/" + trans_id;
                            }
                            else {
                                window.location.href= "#/app/manual-payment" ;
                            }
                        }

                    }
                ]
            });
        }
    };

    $scope.showFailedAlert = function () {
        var alertPopup = $ionicPopup.alert({
            title: 'Checkout',
            css: 'cp-button',
            okType:'cp-button',
            template: '<div style="width:100%;text-align:center">'+$scope.text_failed_alert+'</div>'
        });
    };

    //COMPRO TODO: custom feedback massage untuk barang yang gak available

    $scope.showUnavailableAlert = function (unavailable_product) {
        var alertPopup = $ionicPopup.alert({
            title: 'Checkout',
            css: 'cp-button',
            okType:'cp-button',
            templateUrl: 'templates/unavailable-shopping-cart.html',
            scope: $scope,
            buttons: [
                {
                    text: 'Remove',
                    type: 'cp-button',
                    onTap: function(e)
                    {
                        for(var i=0; i<unavailable_product.length; i++) {
                            for(var j=0; j<shoppingCharts.length; j++) {
                                if(unavailable_product[i]['id'] == shoppingCharts[j].id) {
                                    shoppingCharts.splice(j,1);
                                    continue;
                                }
                            }
                        }
                        $scope.totalPrice = 0;
                        $scope.totalQty = 0;
                        for (var i = 0; i < shoppingCharts.length; i++) {
                            $scope.totalPrice += (shoppingCharts[i].price * shoppingCharts[i].qty);
                            $scope.totalQty += shoppingCharts[i].qty;
                        }
                        $rootScope.totalQty = $scope.totalQty;
                    }

                }
            ]
        });
    };

    function openBrowser(url){
        if (!isPhoneGap()){
            window.open(url,'_blank','location=yes'); 
        }
        else {
            cordova.ThemeableBrowser.open(url, '_blank', {
                statusbar: {
                    color: '#ffffffff'
                },
                toolbar: {
                    height: 44,
                    color: '#ffffffff'
                },
                title: {
                    color: '#212121ff',
                    showPageTitle: true
                },
                backButton: {
                    wwwImage: 'images/drawable-xhdpi/back.png',
                    wwwImagePressed: 'images/drawable-xhdpi/back_pressed.png',
                    wwwImageDensity: 2,
                    align: 'left',
                    event: 'backPressed'
                },
                forwardButton: {
                    wwwImage: 'images/drawable-xhdpi/forward.png',
                    wwwImagePressed: 'images/drawable-xhdpi/forward_pressed.png',
                    wwwImageDensity: 2,
                    align: 'left',
                    event: 'forwardPressed'
                },
                closeButton: {
                    wwwImage: 'images/drawable-xhdpi/close.png',
                    wwwImagePressed: 'images/drawable-xhdpi/close_pressed.png',
                    wwwImageDensity: 2,
                    align: 'right',
                    event: 'closePressed'
                },
                backButtonCanClose: true
            });
        }        
    };

});